/*
 * Subset of Influx API covered by Influx CLI
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * API version: 2.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package api

import (
	"encoding/json"
)

// LegacyAuthorizationPostRequest struct for LegacyAuthorizationPostRequest
type LegacyAuthorizationPostRequest struct {
	// Status of the token. If `inactive`, requests using the token will be rejected.
	Status *string `json:"status,omitempty" yaml:"status,omitempty"`
	// A description of the token.
	Description *string `json:"description,omitempty" yaml:"description,omitempty"`
	// The ID of the organization that the authorization is scoped to.
	OrgID string `json:"orgID" yaml:"orgID"`
	// The ID of the user that the authorization is scoped to.
	UserID *string `json:"userID,omitempty" yaml:"userID,omitempty"`
	// A name that you provide for the authorization.
	Token *string `json:"token,omitempty" yaml:"token,omitempty"`
	// A list of permissions that provide `read` and `write` access to organization resources. An authorization must contain at least one permission.
	Permissions []Permission `json:"permissions" yaml:"permissions"`
}

// NewLegacyAuthorizationPostRequest instantiates a new LegacyAuthorizationPostRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLegacyAuthorizationPostRequest(orgID string, permissions []Permission) *LegacyAuthorizationPostRequest {
	this := LegacyAuthorizationPostRequest{}
	var status string = "active"
	this.Status = &status
	this.OrgID = orgID
	this.Permissions = permissions
	return &this
}

// NewLegacyAuthorizationPostRequestWithDefaults instantiates a new LegacyAuthorizationPostRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLegacyAuthorizationPostRequestWithDefaults() *LegacyAuthorizationPostRequest {
	this := LegacyAuthorizationPostRequest{}
	var status string = "active"
	this.Status = &status
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *LegacyAuthorizationPostRequest) GetStatus() string {
	if o == nil || o.Status == nil {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetStatusOk() (*string, bool) {
	if o == nil || o.Status == nil {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *LegacyAuthorizationPostRequest) HasStatus() bool {
	if o != nil && o.Status != nil {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *LegacyAuthorizationPostRequest) SetStatus(v string) {
	o.Status = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *LegacyAuthorizationPostRequest) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *LegacyAuthorizationPostRequest) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *LegacyAuthorizationPostRequest) SetDescription(v string) {
	o.Description = &v
}

// GetOrgID returns the OrgID field value
func (o *LegacyAuthorizationPostRequest) GetOrgID() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrgID
}

// GetOrgIDOk returns a tuple with the OrgID field value
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetOrgIDOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrgID, true
}

// SetOrgID sets field value
func (o *LegacyAuthorizationPostRequest) SetOrgID(v string) {
	o.OrgID = v
}

// GetUserID returns the UserID field value if set, zero value otherwise.
func (o *LegacyAuthorizationPostRequest) GetUserID() string {
	if o == nil || o.UserID == nil {
		var ret string
		return ret
	}
	return *o.UserID
}

// GetUserIDOk returns a tuple with the UserID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetUserIDOk() (*string, bool) {
	if o == nil || o.UserID == nil {
		return nil, false
	}
	return o.UserID, true
}

// HasUserID returns a boolean if a field has been set.
func (o *LegacyAuthorizationPostRequest) HasUserID() bool {
	if o != nil && o.UserID != nil {
		return true
	}

	return false
}

// SetUserID gets a reference to the given string and assigns it to the UserID field.
func (o *LegacyAuthorizationPostRequest) SetUserID(v string) {
	o.UserID = &v
}

// GetToken returns the Token field value if set, zero value otherwise.
func (o *LegacyAuthorizationPostRequest) GetToken() string {
	if o == nil || o.Token == nil {
		var ret string
		return ret
	}
	return *o.Token
}

// GetTokenOk returns a tuple with the Token field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetTokenOk() (*string, bool) {
	if o == nil || o.Token == nil {
		return nil, false
	}
	return o.Token, true
}

// HasToken returns a boolean if a field has been set.
func (o *LegacyAuthorizationPostRequest) HasToken() bool {
	if o != nil && o.Token != nil {
		return true
	}

	return false
}

// SetToken gets a reference to the given string and assigns it to the Token field.
func (o *LegacyAuthorizationPostRequest) SetToken(v string) {
	o.Token = &v
}

// GetPermissions returns the Permissions field value
func (o *LegacyAuthorizationPostRequest) GetPermissions() []Permission {
	if o == nil {
		var ret []Permission
		return ret
	}

	return o.Permissions
}

// GetPermissionsOk returns a tuple with the Permissions field value
// and a boolean to check if the value has been set.
func (o *LegacyAuthorizationPostRequest) GetPermissionsOk() (*[]Permission, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Permissions, true
}

// SetPermissions sets field value
func (o *LegacyAuthorizationPostRequest) SetPermissions(v []Permission) {
	o.Permissions = v
}

func (o LegacyAuthorizationPostRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Status != nil {
		toSerialize["status"] = o.Status
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if true {
		toSerialize["orgID"] = o.OrgID
	}
	if o.UserID != nil {
		toSerialize["userID"] = o.UserID
	}
	if o.Token != nil {
		toSerialize["token"] = o.Token
	}
	if true {
		toSerialize["permissions"] = o.Permissions
	}
	return json.Marshal(toSerialize)
}

type NullableLegacyAuthorizationPostRequest struct {
	value *LegacyAuthorizationPostRequest
	isSet bool
}

func (v NullableLegacyAuthorizationPostRequest) Get() *LegacyAuthorizationPostRequest {
	return v.value
}

func (v *NullableLegacyAuthorizationPostRequest) Set(val *LegacyAuthorizationPostRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableLegacyAuthorizationPostRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableLegacyAuthorizationPostRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLegacyAuthorizationPostRequest(val *LegacyAuthorizationPostRequest) *NullableLegacyAuthorizationPostRequest {
	return &NullableLegacyAuthorizationPostRequest{value: val, isSet: true}
}

func (v NullableLegacyAuthorizationPostRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLegacyAuthorizationPostRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
